' NOTE: the physics renderer includes "tokamak-c.bi" also !
#include "glRenderer.bi" 

' Renderer([iWidth],[iHeight],[bFullscreen])
' Renderer.CanvasWidth()
' Renderer.CanvasHeight()
' Renderer.Cls()
' Renderer.Text()
' Renderer.Show()
' Renderer.Advance()

' CreateSimulator()
' SimulatorAdvance()
' DestroySimulator()

' This is the classic "hello world" program in physics render style.
' You can use it as template for your own first steps.

'
' main
'
' create the [p]hysics [g]raphic [r]enderer (with default settings)
var pgr = glRenderer()

' you can define your own canvas size like this:
' var pgr = Renderer(800,480)

' create the physics simulator (with default settings)
var sim = createSimulator()

' add your physics objects
' ...

WindowTitle "file: '01_hello_world.bas'"

' no hello world program without a message :-)
var message = "hello world of physics !"

' Only for fun center the message on canvas
' it shows you how to get the current canvas size.
var centerX = pgr.CanvasWidth() / 2.0f - len(message)*4 ' 4 is (CharWidth = 8) / 2
var centerY = pgr.CanvasHeight()/ 2.0f - 8              ' 8 is (CharHeight=16) / 2

' main loop
while inkey()=""
  ' advance the "empty" simulation one step in time
  SimulatorAdvance(sim) ' default is 60 Hz (deltaTime = 1.0/60)
  
  ' clear the render canvas
  pgr.cls
  
  ' set the camera position and direction
  ' ...
  
  ' render all your physics 3D objects on canvas
  ' ...

  ' draw the message centered on canvas
  pgr.Text(centerX, centerY, message)
    
  ' show the canvas on screen
  pgr.show
  
  ' !!!!!!!!!!!!!
  ' ! IMPORTANT !
  ' !!!!!!!!!!!!!
  ' advance the renderer one frame in time
  ' update: frame counter,runtime,timescale,fps the frame rate ...
  pgr.Advance
wend
' (optional but clean coding style)
' destroy the instance of the simulator and all used resoures
DestroySimulator(sim)

