#include "glRenderer.bi" 

' test of: 

' Renderer.Mode2d() ' <-- new in this example
' Renderer.Frame()  ' <-- new in this example
' Renderer.FPS()    ' <-- new in this example

' CreateSimulator()
' SimulatorAdvance()
' DestroySimulator()


' Near the same as "01_hello_world.bas" but in fullscreen !

' It shows you how to en-/disable the 2D render mode.
' if you draw a single line 2D text the text command will temporary enable and disable the 2D mode for you.
' but if you will draw more than one 2D graphics or 2D text it's recommended to enable the 2D mode manually

' create the [p]hysics [g]raphic [r]enderer in full screen
var pgr = glRenderer(,,True) ' ([iWidth],[iHeight],[bFullscreen=False])

' you can define your own canvas full screen resolution like this:
' var pgr = Renderer(800,600,true)

' if your selected fullscreen resolution are not supported the next nearest 
' resolution will be tryed if this fails a "normal" window will be created instead.

' create the physics simulator (with default settings)
var sim = createSimulator()

' add your physics objects
' ...

' in full screen there is no visible WindowTitle :-)
var title = "file: '02_hello_world_fullscreen.bas'"

' main loop
while inkey()=""
  ' advance the "empty" simulation one step in time
  SimulatorAdvance sim 
  
  ' clear the render canvas
  pgr.Cls
  
  ' set the camera position and direction
  ' ...
  
  ' render all your physics 3D objects on canvas
  ' ...
  
  ' enable 2D render mode
  pgr.Mode2d(true)

    ' output prgram name as 2D text
    pgr.Text(0, 0, title)
    pgr.Text(0,16, "canvas: " & pgr.CanvasWidth() & " x " & pgr.CanvasHeight() )
    ' output current frame and frame rate as 2D text
    pgr.Text(0,32, "frame: " & pgr.Frame & " fps: " & pgr.FPS)

  ' disable 2D mode  (switch back to 3D mode)
  pgr.Mode2D(false)
    
  ' show the canvas on screen
  pgr.show
  
  ' !!!!!!!!!!!!!
  ' ! IMPORTANT !
  ' !!!!!!!!!!!!!
  ' advance the renderer one frame in time
  ' update: frame counter, runtime, timescale, fps ...
  ' if vsync=false sleep 1,1 is called also
  pgr.Advance()
wend
' (optional but clean coding style)
' destroy the instance of the simulator and all used resoures
DestroySimulator(sim)

