#include "glRenderer.bi" 

' In this example I create an animated body as an 2m x 2m x 2m cube in 4 steps. 
' (in next example I show you the same result with one command)

'test of:
' SimulatorCreateAnimatedBody()
' AnimatedBodyAddGeometry()
' GeometrySetCubeSize() 
' AnimatedBodyUpdateBoundingInfo()

' AnimatedBodySetPositionRotation()

' Renderer.LookAt()
' Renderer.Render(neAnimatedBody)

'
' main
'
' create the renderer
var pgr = glRenderer()

WindowTitle "file: '10_neAnimatedBody_classic.bas'"

' create the physics simulator
var sim = CreateSimulator()

' a simple cube in 4 steps (the classic way)
' step 1: create an animated body
var body = SimulatorCreateAnimatedBody(sim)
' step 2:  add a shapeless collision geometry to the body (you can add more than one collison shapes to a body)
var geo  = AnimatedBodyAddGeometry(body)
' step 3: set the collision shape of the geometry as a 2m x 2m x 2m cube
GeometrySetCubeSize(geo, 2.0f) 
' step 4: tell the body we are fin with adding stuff (update the internal state of the animated body)
AnimatedBodyUpdateBoundingInfo(body)

' set the camera position (10m back)
pgr.LookAt(0,0,10)

dim as single w

' main loop
while inkey() = ""
  ' advance the simulation one step in time
  SimulatorAdvance(sim)
  ' animate the neAnimatedBody
  var y = neSin(w)*3 : w += pgr.Timescale()
  AnimatedBodySetPositionRotation(body,0,y,0, w*10,w*20,w*30)
  ' clear the render canvas
  pgr.cls
  ' render the cube as 3D objects on canvas
  pgr.render(body)
  ' draw the frame rate on canvas
  pgr.Text(0,0,"fps: " & pgr.FPS)
  ' show the canvas on screen
  pgr.show
  ' advance the renderer one frame in time
  pgr.Advance
  '  
wend
' (optional but clean coding style)
' destroy the instance of the simulator 
DestroySimulator(sim)
