#include "glRenderer.bi" 

' near the same as "03_neAnimatedBody_classic.bas" (4 commands was needed)

' In this example I create a simple animted body as cube with only one command. 

' test of:
' CreateAnimatedBodyCube()
'
' main
'
' create the renderer
var pgr = glRenderer()

WindowTitle "file: '11_neAnimatedBody.bas'"

' create the physics simulator
var sim = CreateSimulator()
' create an animated body as 2m x 2m x 2m cube
var body = CreateAnimatedBodyCube(sim,2)

' set the camera position (10m back so we can see the cube at the origin)
pgr.LookAt(0,0,10)

dim as single w
' main loop
while inkey() = ""
  ' advance the simulation one step in time
  SimulatorAdvance(sim)
  ' animate the body
  var y = neSin(w)*3 : w += pgr.Timescale()
  AnimatedBodySetPositionRotation(body,0,y,0, w*10,w*20,w*30)
  
  ' clear the render canvas
  pgr.cls
  ' render the cube as 3D objects on canvas
  pgr.render(body)
  ' draw the frame rate on canvas
  pgr.Text(0,0,"fps: " & pgr.FPS)
  ' show the canvas on screen
  pgr.show
  ' advance the renderer one frame in time
  pgr.Advance
wend
' (optional but clean coding style)
' destroy the instance of the simulator 
DestroySimulator(sim)
