' NOTE: the physics renderer includes "tokamak-c.bi" also !
#include "glRenderer.bi" 

' In this example I create an rigid body box with 1 command 

'test of:

' CreateRigidBodyBox()

'
' main
'
' create the renderer
var pgr = glRenderer()

WindowTitle "file: '21_neRigidBody.bas'"

' create the physics simulator
var sim = CreateSimulator()

' create a 200m x 2m x 200m (static) box as ground
var ground = CreateAnimatedBodyBox(sim, 200,1,200)
AnimatedBodySetPosition(ground, 0,-.5,0)

' Create a rigid body box size: 1m x 2m x 3m mass: 10Kg  (with only 1 command)
var body = CreateRigidBodyBox(sim, 1,2,3, 10)
RigidBodySetPosition(body, 0,10,0)

' set the camera position (3m up and 10m back)
pgr.LookAt(0,3,10)

dim as string text 

' main loop
while inkey() = ""
  ' advance the simulation one step in time
  SimulatorAdvance(sim)
  ' clear the render canvas
  pgr.cls
  ' render the ground object
  pgr.render(ground)
  ' render the rigid body box 
  pgr.render(body)
' draw the frame rate on canvas
  text = "fps: " & pgr.FPS & iif(SimulatorGetIdleBodyCount(sim)>0," Be quiet the cute box is sleeping now !","")
  pgr.Text(0,0, text)
  ' show the canvas on screen
  pgr.show
  ' advance the renderer one frame in time
  pgr.Advance
  '  
wend
DestroySimulator(sim)
