#include "glRenderer.bi"  

' In this example I create a buch of rigid bodies

' test of:
' neRnd(min,max)
' CreateRigidBodyCube(sim,[size],[mass])
' CreateRigidBodyBox(sim,[width],[height],[depth],[mass])
' CreateRigidBodySphere(sim,[diameter],[mass])
' CreateRigidBodyCapsule(sim,[diameter],[heigh],[mass])
' GroundShadow(true|false)

'
' main
'
randomize(0)
var pgr = glRenderer(,,true)
WindowTitle "file: '22_neRigidBodies.bas'"

var sim = CreateSimulator()

' use an array of rigidbodies instances
dim as neRigidBody ptr bodies(DEFAULT_RIGIDBODIES_COUNT-1)

for i as integer = 0 to ubound(bodies)
  select case as const i and 3
  case 0 : var r = neRnd(.5,2),mass=4/3*NE_PI*r^3
           bodies(i) = CreateRigidBodySphere(sim,r*2,mass)
           RigidBodySetAngularDamping(bodies(i),.005f)
           RigidBodySetLinearDamping (bodies(i),.005f)
  case 1 : var r = neRnd(.5,2),h=neRnd(.5,2),mass=NE_PI*r^2*(4/3*r+h)
           bodies(i) = CreateRigidBodyCapsule(sim,r*2,h,mass)
           RigidBodySetLinearDamping (bodies(i),.005f)
           RigidBodySetAngularDamping(bodies(i),.005f)
  case 2 : var size=neRnd(.5,2),mass=size*size*size
           bodies(i) = CreateRigidBodyCube(sim,size,mass)            
  case 3 : var w=neRnd(.5,2),h=neRnd(.5,2),d=neRnd(.5,2),mass=w*h*d 
           bodies(i) = CreateRigidBodyBox(sim,w,h,d,mass)           
  end select
  var x = neRnd(-10,10), y = 1+i, z = neRnd(-10,10)
  RigidBodySetPositionRotation(bodies(i), x,y,z, rnd*360,rnd*360,rnd*360)
  
next

' create a 200m x 2m x 200m (static) box as ground
var ground = CreateAnimatedBodyBox(sim, 200,2,200)
AnimatedBodySetPosition(ground, 0,-1,0)

' set the camera position
pgr.LookAt(0,10,50)

' main loop
while inkey() = ""
  SimulatorAdvance(sim)
  
  pgr.Cls
  pgr.Render(ground) 
  
  pgr.GroundShadow(true) ' enable ground shadow rendering
    for i as integer = 0 to ubound(bodies)
      pgr.Render(bodies(i)) ' draw the bodies "shadows"
    next
  pgr.GroundShadow(false) ' disable ground shadow rendering
  
  for i as integer = 0 to ubound(bodies)
    pgr.Render(bodies(i)) ' draw the bodies "normal"
  next
  pgr.Text(0,0,"fps: " & pgr.fps)
  pgr.Show()
  pgr.Advance()
wend
DestroySimulator(sim)
