#include "glRenderer.bi"
#include "neGround.bi"

function CreateCombinedRigidBody(sim as neSimulator ptr) as neRigidBody ptr
  var rb = SimulatorCreateRigidBody(sim)

  var boxLB = RigidBodyAddGeometry(rb)
  var boxRB = RigidBodyAddGeometry(rb)
  var boxLF = RigidBodyAddGeometry(rb)
  var boxRF = RigidBodyAddGeometry(rb)    

  GeometrySetBoxSize(boxLB,1,1,1)
  GeometrySetBoxSize(boxRB,1,1,1)
  GeometrySetBoxSize(boxLF,1,1,1)
  GeometrySetBoxSize(boxRF,1,1,1)

  GeometrySetPosition(boxLB,-1, 0,-1)
  GeometrySetPosition(boxRB, 1, 0,-1)  
  GeometrySetPosition(boxLF,-1, 0, 1)
  GeometrySetPosition(boxRF, 1, 0, 1)
    
  RigidBodyUpdateBoundingInfo(rb)
 
  return rb
end function  
'
' main
'
var gfx = glRenderer()
windowtitle "file: '23_neRigidBodies_combined.bas'"
var sim = CreateSimulator()
var mesh = new neGround()
SimulatorSetTerrainMesh(sim, mesh)

var rb1 = CreateCombinedRigidBody(sim)
RigidBodySetInertiaTensorV3(rb1,SphereInertiaTensorV3(10, 100))
RigidBodySetMass(rb1, 100)
'RigidBodyUpdateBoundingInfo(rb1)
RigidBodySetPositionRotation(rb1,-5,17,0 ,15,15,15)

var rb2 = CreateCombinedRigidBody(sim)
RigidBodySetInertiaTensorV3(rb2,BoxInertiaTensorV3(3,1,3, 100))
RigidBodySetMass(rb2, 100)
'RigidBodyUpdateBoundingInfo(rb2)
RigidBodySetPositionRotation(rb2, 5,17,0 ,15,15,15)

gfx.LookAt(0,1.7,20, 0,2,0, 0,1,0)

while inkey()=""
  SimulatorAdvance(sim)
  gfx.Cls
  gfx.Render(mesh)
    
  gfx.GroundShadow(true)
    gfx.Render(rb1)
    gfx.Render(rb2)
  gfx.GroundShadow(false)
    
  gfx.Render(rb1)
  gfx.Render(rb2)
    
  gfx.Mode2D(true)
    gfx.Text(0,0,"fps: " & gfx.fps)
    gfx.Text(gfx.CanvasWidth/4*1,gfx.CanvasHeight/2,"sphere tensor")
    gfx.Text(gfx.CanvasWidth/4*3,gfx.CanvasHeight/2,"box tensor")
  gfx.Mode2D(false)
    
  gfx.Show()
  gfx.Advance()
wend
DestroySimulator(sim)


