#include "glRenderer.bi" 

' In this file I show you how easy you can extend the neTriangleMesh class 
#include "neGround.bi"

' test of:
'  class neGround
'  SimulatorSetTerrainMesh(neGround)
'  SetMesh(neGround)
'  Render(neGround)

'
' main
'
' create the [p]hysics [g]raphic [r]enderer (with default settings)
var pgr = glRenderer()
 
windowtitle "create neSimulator ..."
var sim = CreateSimulator()

windowtitle "create neGround ..."
var ground = new neGround()

windowtitle "set neGround as terrain ..."
SimulatorSetTerrainMesh(sim, ground)

windowtitle "create some rigid bodies ..."
dim as neRigidBody ptr bodies(DEFAULT_RIGIDBODIES_COUNT-1)
for i as integer = 0 to ubound(bodies)
  select case as const i and 3
  case 0    : bodies(i) = CreateRigidBodyBox(sim)
  case 1    : bodies(i) = CreateRigidBodyCapsule(sim,1,.5)
  case else : bodies(i) = CreateRigidBodySphere(sim)
              RigidBodySetAngularDamping(bodies(i),0.1)
  end select
  
  RigidBodySetLinearDamping(bodies(i),0.01)
  
  dim as single xp = (rnd-rnd)*50
  dim as single yp = 30+i
  dim as single zp = (rnd-rnd)*50
  RigidBodySetPositionRotation(bodies(i), xp,yp,zp, rnd*359,rnd*359,rnd*359)
next

windowtitle "30_neGround.bas"

dim as neV3 observer
dim as single w

while inkey()=""
  SimulatorAdvance(sim) ' 60 Hz
  pgr.Advance()
  if (pgr.Frame and 1) then ' 30 Hz
    ' only for fun rotate the observer around the center
    with observer
      .x = neCos(w)*50
      .z = neSin(w)*50
      .y = 1.6 + 10 + neSin(w)*10
    end with  
    ' advance the rotation (15 degree per seconds)
    w += Deg2Rad*15*pgr.Timescale
    
    ' look from observer position to center
    pgr.LookAt(observer)
    
    ' clear the render canvas
    pgr.cls
    
    ' render the ground mesh
    pgr.Render(ground)
    
    pgr.GroundShadow(true)
      ' render the bodies as ground shadow
      for i as integer = 0 to ubound(bodies)
        pgr.Render(bodies(i))
      next
    pgr.GroundShadow(false)  
    
    ' render the bodies
    for i as integer = 0 to ubound(bodies)
      pgr.Render(bodies(i))
    next   
    
    ' output fps
    pgr.Text(0,0,"fps: " & pgr.FPS)
    
    ' show canvas on screen
    pgr.Show()
  end if
wend

DestroySimulator(sim)

