#include "glRenderer.bi" 
#include "neGround.bi" 

' test of:
' SimulatorCreateRigidBodyWorldJoint
' JointSetType(joint, NE_BALLSOCKET)
' JointSetPositionRotationFrameWorld
' JointEnable()
' Render(joint)

var gfx = glRenderer()
WindowTitle "file: '50_Ball_Socket_neJoint.bas'"
var sim = CreateSimulator()

var mesh = new neGround()
SimulatorSetTerrainMesh(sim, mesh)

var mass = 10.0,TimeStep=1.0/60, G=9.81

var box = CreateRigidBodyBox(sim, .5,1,2, mass)
RigidBodySetPosition(box, 9,10,0)
RigidBodyApplyImpulse(box, 0,0,100)

' create a ball and socket joint nailed on a point of the world.
var joint = SimulatorCreateRigidBodyWorldJoint(sim,box)
JointSetType(joint,NE_BALLSOCKET)
JointSetPositionRotationFrameWorld(joint, 0,10,0, 0,0,0)
JointSetDampingFactor(joint,mass*mass*G*TimeStep)
JointEnable(joint,true)

gfx.LookAt(0,1.7,25) 
while inkey()=""
  SimulatorAdvance(sim,TimeStep) ' 60 Hz.
  gfx.Advance()
  gfx.Cls 
  gfx.Render(mesh)
  gfx.GroundShadow(true)
    gfx.Render(box)
    gfx.Render(joint)
  gfx.GroundShadow(false)
  gfx.Render(box)
  gfx.Render(joint)
  gfx.Text(8,8,"fps: " & gfx.fps & " frame: " & gfx.Frame)
  gfx.Show()  
wend
DestroySimulator(sim)

