#include "glRenderer.bi" 

' test of:
' SimulatorCreateRigidBodyWorldJoint
' JointSetPositionRotationFrameWorld
' JointEnable
' gfx.Render(joint)

var sim = CreateSimulator()

var ground = CreateAnimatedBodyBox(sim,50,1,50)
AnimatedBodySetPosition(ground,0,-.5,0)

var box = CreateRigidBodyCube(sim,1,10)
RigidBodySetPosition(box,8,10,0)

var joint = SimulatorCreateRigidBodyWorldJoint(sim,box)
JointSetType(joint,NE_BALLSOCKET)
JointSetPositionRotationFrameWorld(joint, 0,10,0, 0,0,0)
JointSetDampingFactor(joint,neSqr(RigidbodyGetMass(box)))
JointEnable(joint,true)


dim as glRenderer gfx
while inkey()=""
  SimulatorAdvance(sim) ' 60 Hz.
  gfx.Advance()
  if (gfx.frame and 1) then ' 30 Hz.
    gfx.cls
    glLoadIdentity()
    glTransLatef (0,-4,-15) 
    gfx.Render(ground)
    gfx.Render(box)
    gfx.Render(joint)
    gfx.Show()
  end if    


wend

DestroySimulator(sim)

