#include "glRenderer.bi"

' example of (simple) slider joint

var sim = CreateSimulator() 

var ground = CreateAnimatedBodyBox(sim,20,1,20) : AnimatedBodySetPosition(ground,0,-.5,0)
' create two cubes at y positin 3m and 7m
var cube1 = CreateRigidBodyCube(sim) : RigidBodySetPositionRotation(cube1, 0,7,0, 0,0,0)
var cube2 = CreateRigidBodyCube(sim) : RigidBodySetPositionRotation(cube2, 0,3,0, 0,0,0)
' connect the two rigidbody cubes with a joint
var joint = SimulatorCreateRigidBodyRigidBodyJoint(sim,cube1,cube2)
' set the new created joint as slider constraint
JointSetType(joint,NE_SLIDER)
' set the minimum distane to 1.5m
' set the maximum distane to 3.0m
JointSetLowerLimit(joint,1.5)
JointSetUpperLimit(joint,3.0)
' enable the minimum and maximum limits
JointLimitEnable(joint, true)
' enable the the slider constraint
JointEnable(joint, true)
' reduce the sleeping parameter (=more time to go in sleep mode)

' (comment it out and see what happens)
RigidBodySetSleepingParameter(cube1,0.02)
RigidBodySetSleepingParameter(cube2,0.02)

var gfx = glRenderer()
gfx.LookAt(0,2,10, 0,2,0) 

while inkey()=""

  SimulatorAdvance(sim)
  gfx.Advance()
  if gfx.frame=300 then 
    JointSetLowerLimit(joint,3)
    if RigidBodyIsIdle(cube1) then RigidBodyWakeup(cube1)
    if RigidBodyIsIdle(cube2) then RigidBodyWakeup(cube2)
  end if  
  gfx.Cls
  
  gfx.Render(ground)
#ifndef NO_GROUNDSHADOW
  gfx.GroundShadow(true)
    gfx.Render(cube1)
    gfx.Render(cube2)
    gfx.Render(joint)
  gfx.GroundShadow(false)    
#endif  
  gfx.Render(cube1)
  gfx.Render(cube2)
  gfx.Render(joint)
  
  gfx.Text(0,0,"fps: " & gfx.fps & " frame: " & gfx.frame)

  gfx.Show
wend

DestroySimulator(sim)

