#include "glRenderer.bi"


sub JointControllerCallback cdecl (byval controller as neJointController ptr, byval timeStep as single)

end sub

var sim = CreateSimulator() 

var ground = CreateAnimatedBodyBox(sim,20,1,20)
AnimatedBodySetPosition(ground,0,-.5,0)

var cube1 = CreateRigidBodyCube(sim) : RigidBodySetPositionRotation(cube1, 0,5,0, 0,0,0)
var cube2 = CreateRigidBodyCube(sim) : RigidBodySetPositionRotation(cube2, 0,3,0, 0,0,0)
var joint = SimulatorCreateRigidBodyRigidBodyJoint(sim,cube1,cube2)

JointSetType(joint,NE_SLIDER)
JointSetLowerLimit(joint,1.5)
JointSetUpperLimit(joint,5)
JointLimitEnable(joint,true)
JointEnable(joint,true)

var gfx = glRenderer()
gfx.LookAt(0,1.7,10, 0,.5,0) 
dim as string text

while inkey()=""

  SimulatorAdvance(sim) ' 60 Hz.
  gfx.Advance()
  
  gfx.Cls
  
  gfx.Render(ground)

  gfx.GroundShadow(true)
    gfx.Render(cube1)
    gfx.Render(cube2)
    gfx.Render(joint)
  gfx.GroundShadow(false)    
  
  gfx.Render(cube1)
  gfx.Render(cube2)
  gfx.Render(joint)
  
  gfx.Text(0,0,"fps: " & gfx.fps & " frame: " & gfx.frame)

  gfx.Show
wend

DestroySimulator(sim)

