#include "glRenderer.bi"

var sim = CreateSimulator() 

var ground = CreateAnimatedBodyBox(sim,200,1,200)
AnimatedBodySetPosition(ground,0,-.5,0)

var cube = CreateRigidBodyCube(sim,1)
RigidBodySetPositionRotation   (cube, 0,.5,0, 0,0,0)
RigidBodySetSleepingParameter(cube,0.02)

var joint = SimulatorCreateRigidBodyWorldJoint(sim,cube)
JointSetType(joint,NE_SLIDER)
'JointSetPositionRotationFrameWorld(joint,0,.5,0, 80,0,0)

dim as single limit=.5,direction=1
JointSetLowerLimit(joint,limit)
JointSetUpperLimit(joint,limit)
JointLimitEnable(joint,true)
JointEnable(joint,true)

var gfx = glRenderer()

var LookFrom = neV3(0,10,20)

while inkey()=""

  SimulatorAdvance(sim)
  gfx.Advance()
  
  if (gfx.Frame mod 200)=0 then
    if limit<1 or limit>10 then direction*=-1
    limit+=direction*2
    JointSetLowerLimit(joint,limit)
    JointSetUpperLimit(joint,limit)
    if RigidBodyIsIdle(cube) then
      RigidBodyWakeUp(cube) 
    end if  
  end if
  
  var LookTo = RigidbodyGetPositionV3(cube)
  gfx.LookAt(LookFrom,LookTo)
  
  
  gfx.Cls
  
  gfx.Render(ground)

  gfx.GroundShadow(true)
    'gfx.Render(Nail)
    gfx.Render(cube)
    gfx.Render(joint)
  gfx.GroundShadow(false)    
  
  'gfx.Render(Nail)
  gfx.Render(cube)
  gfx.Render(joint)
  
  gfx.Text(0,0,"fps: " & gfx.fps & " frame: " & gfx.frame)

  gfx.Show
wend

DestroySimulator(sim)

