#include "glRenderer.bi"

' example of simple slider motor
var sim = CreateSimulator() 

var ground = CreateAnimatedBodyBox(sim,200,1,200)
AnimatedBodySetPosition(ground,0,-.5,0)

var cube = CreateRigidBodyCube(sim,1): RigidBodySetPosition(cube, 0,.5,0)
var joint = SimulatorCreateRigidBodyWorldJoint(sim,cube)
JointSetType(joint,NE_SLIDER)
JointSetLowerLimit(joint,15)
JointSetUpperLimit(joint,15)
JointLimitEnable(joint,true)

JointSetMotor(joint,50,1) ' desire velocity, max force
JointMotorEnable(joint,true)
JointEnable(joint,true)

var gfx = glRenderer()

var LookFrom = neV3(0,10,20)

while inkey()=""

  SimulatorAdvance(sim) ' 60 Hz.
  var LookTo = RigidbodyGetPositionV3(cube)
  gfx.LookAt(LookFrom,LookTo)
  gfx.Advance()
  
  gfx.Cls
  
  gfx.Render(ground)
#ifndef NO_GROUNDSHADOW
  gfx.GroundShadow(true)
    gfx.Render(cube)
    gfx.Render(joint)
  gfx.GroundShadow(false)    
#endif  
  gfx.Render(cube)
  gfx.Render(joint)
  
  gfx.Text(0,0,"fps: " & gfx.fps & " frame: " & gfx.frame)

  gfx.Show
wend

DestroySimulator(sim)

