#pragma once

' code from GLU library

' [glu]Perspective, [glu]Unproject and [glu]Project as float version.

' r4x4 = inverse(m4x4) (return false = no solution)
function inv_mat4x4f(byref r as single ptr,byref m as const single ptr) as boolean
  dim as single tmp(3,7)=any, m0=any, m1=any, m2=any, m3=any, s=any
  dim as single ptr r0 = @tmp(0,0)
  dim as single ptr r1 = @tmp(1,0)
  dim as single ptr r2 = @tmp(2,0)
  dim as single ptr r3 = @tmp(3,0)
  r0[0] = m[ 0] : r0[1] = m[ 4] : r0[2] = m[ 8] : r0[3] = m[12]
  r1[0] = m[ 1] : r1[1] = m[ 5] : r1[2] = m[ 9] : r1[3] = m[13]
  r2[0] = m[ 2] : r2[1] = m[ 6] : r2[2] = m[10] : r2[3] = m[14]
  r3[0] = m[ 3] : r3[1] = m[ 7] : r3[2] = m[11] : r3[3] = m[15]
  ' identy
  r0[4] = 1.0f  : r0[5] = 0.0f  : r0[6] = 0.0f  : r0[7] = 0.0f
  r1[4] = 0.0f  : r1[5] = 1.0f  : r1[6] = 0.0f  : r1[7] = 0.0f
  r2[4] = 0.0f  : r2[5] = 0.0f  : r2[6] = 1.0f  : r2[7] = 0.0f
  r3[4] = 0.0f  : r3[5] = 0.0f  : r3[6] = 0.0f  : r3[7] = 1.0f

  if (abs(r3[0]) > abs(r2[0])) then swap r3, r2
  if (abs(r2[0]) > abs(r1[0])) then swap r2, r1
  if (abs(r1[0]) > abs(r0[0])) then swap r1, r0
  'if (r0[0] = 0.0f) then return false
  ' !!! m1 = r1[0]/r0[0] : m2 = r2[0]/r0[0] : m3 = r3[0]/r0[0]
  s = r0[0] : if (s = 0.0f) then return false
  s = 1.0f/s : m1 = r1[0]*s : m2 = r2[0]*s : m3 = r3[0]*s
  
  s = r0[1] : r1[1] -= m1*s : r2[1] -= m2*s : r3[1] -= m3*s
  s = r0[2] : r1[2] -= m1*s : r2[2] -= m2*s : r3[2] -= m3*s
  s = r0[3] : r1[3] -= m1*s : r2[3] -= m2*s : r3[3] -= m3*s
  s = r0[4] : if (s <> 0.0f) then r1[4] -= m1*s : r2[4] -= m2*s : r3[4] -= m3*s
  s = r0[5] : if (s <> 0.0f) then r1[5] -= m1*s : r2[5] -= m2*s : r3[5] -= m3*s
  s = r0[6] : if (s <> 0.0f) then r1[6] -= m1*s : r2[6] -= m2*s : r3[6] -= m3*s
  s = r0[7] : if (s <> 0.0f) then r1[7] -= m1*s : r2[7] -= m2*s : r3[7] -= m3*s
     
  if (abs(r3[1]) > abs(r2[1])) then swap r3, r2
  if (abs(r2[1]) > abs(r1[1])) then swap r2, r1
  'if (r1[1]=0.0) then return false
  s = r1[1] : if (s = 0.0f) return false
  
  s = 1.0f/s : m2 = r2[1]*s : m3 = r3[1]*s
  r2[2] -= m2*r1[2] : r2[3] -= m2*r1[3]
  r3[2] -= m3*r1[2] : r3[3] -= m3*r1[3]

  s = r1[4] : if (s <> 0.0f) then r2[4] -= m2*s : r3[4] -= m3*s
  s = r1[5] : if (a <> 0.0f) then r2[5] -= m2*s : r3[5] -= m3*s
  s = r1[6] : if (s <> 0.0f) then r2[6] -= m2*s : r3[6] -= m3*s
  s = r1[7] : if (s <> 0.0f) then r2[7] -= m2*s : r3[7] -= m3*s
  
  if (abs(r3[2]) > abs(r2[2])) then swap r3, r2
  if (r2[2]=0.0f) then return false
   
  m3 = r3[2]/r2[2] : r3[3] -= m3*r2[3]
  if (r3[3]=0.0f) then return false

  r3[4]-=m3*r2[4]
  r3[5]-=m3*r2[5]
  r3[6]-=m3*r2[6]
  r3[7]-=m3*r2[7]

  s = 1.0f / r3[3] : r3[4] *= s : r3[5] *= s : r3[6] *= s : r3[7] *= s
   
  m2 = r2[3] : s = 1.0f / r2[2]
  r2[4] = s*(r2[4] - r3[4]*m2)
  r2[5] = s*(r2[5] - r3[5]*m2)
  r2[6] = s*(r2[6] - r3[6]*m2)
  r2[7] = s*(r2[7] - r3[7]*m2)

  m1 = r1[3] : r1[4] -= r3[4]*m1 : r1[5] -= r3[5]*m1 : r1[6] -= r3[6]*m1 : r1[7] -= r3[7]*m1

  m0 = r0[3] : r0[4] -= r3[4]*m0 : r0[5] -= r3[5]*m0 : r0[6] -= r3[6]*m0 : r0[7] -= r3[7]*m0

  m1 = r1[2] : s = 1.0f / r1[1]
  r1[4] = s*(r1[4] - r2[4]*m1)
  r1[5] = s*(r1[5] - r2[5]*m1)
  r1[6] = s*(r1[6] - r2[6]*m1)
  r1[7] = s*(r1[7] - r2[7]*m1)

  m0 = r0[2] : r0[4] -= r2[4]*m0 : r0[5] -= r2[5]*m0 : r0[6] -= r2[6]*m0 : r0[7] -= r2[7]*m0

  m0 = r0[1] : s = 1.0f / r0[0]
  r0[4] = s*(r0[4] - r1[4]*m0)
  r0[5] = s*(r0[5] - r1[5]*m0)
  r0[6] = s*(r0[6] - r1[6]*m0)
  r0[7] = s*(r0[7] - r1[7]*m0)

  r[ 0] = r0[4] : r[ 1] = r1[4] : r[ 2] = r2[4] : r[ 3] = r3[4]
  r[ 4] = r0[5] : r[ 5] = r1[5] : r[ 6] = r2[5] : r[ 7] = r3[5]
  r[ 8] = r0[6] : r[ 9] = r1[6] : r[10] = r2[6] : r[11] = r3[6]
  r[12] = r0[7] : r[13] = r1[7] : r[14] = r2[7] : r[15] = r3[7]
  return true
end function

' r4x4 = a4x4*b4x4
sub mul_mat4x4f(byref r as       single ptr, _
                byref a as const single ptr, _
                byref b as const single ptr)
  r[ 0]=a[ 0]*b[ 0] + a[ 4]*b[ 1] + a[ 8]*b[ 2] + a[12]*b[ 3]
  r[ 1]=a[ 1]*b[ 0] + a[ 5]*b[ 1] + a[ 9]*b[ 2] + a[13]*b[ 3]
  r[ 2]=a[ 2]*b[ 0] + a[ 6]*b[ 1] + a[10]*b[ 2] + a[14]*b[ 3]
  r[ 3]=a[ 3]*b[ 0] + a[ 7]*b[ 1] + a[11]*b[ 2] + a[15]*b[ 3]

  r[ 4]=a[ 0]*b[ 4] + a[ 4]*b[ 5] + a[ 8]*b[ 6] + a[12]*b[ 7]
  r[ 5]=a[ 1]*b[ 4] + a[ 5]*b[ 5] + a[ 9]*b[ 6] + a[13]*b[ 7]
  r[ 6]=a[ 2]*b[ 4] + a[ 6]*b[ 5] + a[10]*b[ 6] + a[14]*b[ 7]
  r[ 7]=a[ 3]*b[ 4] + a[ 7]*b[ 5] + a[11]*b[ 6] + a[15]*b[ 7]

  r[ 8]=a[ 0]*b[ 8] + a[ 4]*b[ 9] + a[ 8]*b[10] + a[12]*b[11]
  r[ 9]=a[ 1]*b[ 8] + a[ 5]*b[ 9] + a[ 9]*b[10] + a[13]*b[11]
  r[10]=a[ 2]*b[ 8] + a[ 6]*b[ 9] + a[10]*b[10] + a[14]*b[11]
  r[11]=a[ 3]*b[ 8] + a[ 7]*b[ 9] + a[11]*b[10] + a[15]*b[11]

  r[12]=a[ 0]*b[12] + a[ 4]*b[13] + a[ 8]*b[14] + a[12]*b[15]
  r[13]=a[ 1]*b[12] + a[ 5]*b[13] + a[ 9]*b[14] + a[13]*b[15]
  r[14]=a[ 2]*b[12] + a[ 6]*b[13] + a[10]*b[14] + a[14]*b[15]
  r[15]=a[ 3]*b[12] + a[ 7]*b[13] + a[11]*b[14] + a[15]*b[15]
end sub

' r4 = m4x4*v4 (transform)
sub mul_mat4x4f_v4f(byref r4 as       single ptr, _
                    byref m4 as const single ptr, _
                    byref v4 as const single ptr)
  r4[0]=m4[0]*v4[0] + m4[4]*v4[1] + m4[ 8]*v4[2] + m4[12]*v4[3]
  r4[1]=m4[1]*v4[0] + m4[5]*v4[1] + m4[ 9]*v4[2] + m4[13]*v4[3]
  r4[2]=m4[2]*v4[0] + m4[6]*v4[1] + m4[10]*v4[2] + m4[14]*v4[3]
  r4[3]=m4[3]*v4[0] + m4[7]*v4[1] + m4[11]*v4[2] + m4[15]*v4[3]
end sub
' r3 = m4x4*v3  (rotation only)
sub rot_mat4x4f_v3f(byref r3 as       single ptr, _
                    byref m4 as const single ptr, _
                    byref v3 as const single ptr)
  r3[0]=m4[0]*v3[0] + m4[4]*v3[1] + m4[ 8]*v3[2]
  r3[1]=m4[1]*v3[0] + m4[5]*v3[1] + m4[ 9]*v3[2]
  r3[2]=m4[2]*v3[0] + m4[6]*v3[1] + m4[10]*v3[2]
end sub
' r3 = m4x4*v3  (rotation + translation)
sub trans_mat4x4f_v3f(byref r3 as       single ptr, _
                      byref m4 as const single ptr, _
                      byref v3 as const single ptr)
  r3[0]=m4[0]*v3[0] + m4[4]*v3[1] + m4[ 8]*v3[2] + m4[12]
  r3[1]=m4[1]*v3[0] + m4[5]*v3[1] + m4[ 9]*v3[2] + m4[13]
  r3[2]=m4[2]*v3[0] + m4[6]*v3[1] + m4[10]*v3[2] + m4[14]
end sub

' from object space to window coords
function Project(byref ox as const single, _
                 byref oy as const single, _
                 byref oz as const single, _
                 byref mv as const single ptr, _ ' modelview matrix
                 byref pm as const single ptr, _ ' projection matrix
                 byref vp as const long   ptr, _ ' active viewport
                 byref r  as single ptr) as boolean
  dim as single mx=any,my=any,mz=any,invZ=any
  dim as single px=any,py=any,pz=any,pw=any
  
  ' model = object*modelview
  mz = mv[2]*ox + mv[6]*oy + mv[10]*oz + mv[14]
  if (mz = 0.0f) then return false
  mx = mv[0]*ox + mv[4]*oy + mv[ 8]*oz + mv[12]
  my = mv[1]*ox + mv[5]*oy + mv[ 9]*oz + mv[13]
  mw = mv[3]*ox + mv[7]*oy + mv[11]*oz + mv[15]

  ' proj = model*projection
  px = pm[0]*mx + pm[4]*my + pm[ 8]*mz + pm[12]*mw
  py = pm[1]*mx + pm[5]*my + pm[ 9]*mz + pm[13]*mw
  pz = pm[2]*mx + pm[6]*my + pm[10]*mz + pm[14]*mw
  
  invZ=1.0f/-mz : px*=invZ : py*=invZ : pz*=invZ
  ' rX = windowX + (0.5+(px/2))*windowWidth
  r[0]=(px*0.5+0.5)*vp[2] + vp[0]
  ' rY = windowY + (0.5+(py/2))*windowHeight
  r[1]=(py*0.5+0.5)*vp[3] + vp[1]
  ' rZ = (1 + pz) / 2 ' NOTE: this is only correct when glDepthRange(0.0, 1.0)
  r[2]=(1.0+pz)*0.5
  return true
end function


#if 0
function Project(byref ox       as const single, _
                 byref oy       as const single, _
                 byref oz       as const single, _
                 byref mv4x4f   as const single ptr, _ ' modelview matrix
                 byref proj4x4f as const single ptr, _ ' projection matrix
                 byref viewport as const long   ptr, _ ' active viewport
                 byref result   as single ptr) as boolean
  dim as single t(7)=any
  dim as single ptr p=@t(0)
  ' object space to camera space
  ' Z
  p[2] = mv4x4f[2]*ox + mv4x4f[6]*oy + mv4x4f[10]*oz + mv4x4f[14]
  if p[2]=0 then return false
  ' X
  p[0] = mv4x4f[0]*ox + mv4x4f[4]*oy + mv4x4f[ 8]*oz + mv4x4f[12]
  ' Y
  p[1] = mv4x4f[1]*ox + mv4x4f[5]*oy + mv4x4f[ 9]*oz + mv4x4f[13]
  ' W
  p[3] = mv4x4f[3]*ox + mv4x4f[7]*oy + mv4x4f[11]*oz + mv4x4f[15]

  ' camera space to screen space
  ' X
  p[4] = proj4x4f[0]*p[0] + proj4x4f[4]*p[1] + proj4x4f[ 8]*p[2]+ proj4x4f[12]*p[3]
  ' Y
  p[5] = proj4x4f[1]*p[0] + proj4x4f[5]*p[1] + proj4x4f[ 9]*p[2]+ proj4x4f[13]*p[3]
  ' Z
  p[6] = proj4x4f[2]*p[0] + proj4x4f[6]*p[1] + proj4x4f[10]*p[2]+ proj4x4f[14]*p[3]
  
  p[7]=-p[2] : p[7]=1.0/p[7]
  ' pX/mZ pY/mZ pZ/mZ
  p[4]*=p[7] 
  p[5]*=p[7]
  p[6]*=p[7]
  ' rX = x + (0.5+(x/2))*width
  result[0]=(p[4]*0.5+0.5)*viewport[2] + viewport[0]
  ' rY = y + (0.5+(Y/2))*height
  result[1]=(p[5]*0.5+0.5)*viewport[3] + viewport[1]
  ' this is only correct when glDepthRange(0.0, 1.0)
  ' rZ = (1 + z) / 2
  result[2]=(1.0+p[6])*0.5
  return true
end function
#endif

' from window coords to object space (note: wy=WindowHeight-MouseY)
function Unproject(byref wx as const single, _
                   byref wy as const single, _
                   byref wz as const single, _
                   byref mv as const single ptr, _ ' modelview matrix
                   byref pm as const single ptr, _ ' projection matrix
                   byref vp as const long   ptr, _ ' active viewport
                   byref ob as single ptr) as boolean
  dim as single mtmp(15)=any, pmvtmp(15)=any, intmp(3)=any, rtmp(3)=any, w=any
  dim as single ptr invPMV=@mtmp(0)
  dim as single ptr pmv=@pmvtmp(0)
  dim as single ptr in=@intmp(0)
  dim as single ptr r=@rtmp(0)
  ' pmv = pm * mv
  mul_mat4x4f(pmv, pm, mv)
  ' inverse of pmv
  if inv_mat4x4f(invPMV,pmv)=false then return false
  ' window coords to normalized device coords
  ' X = -1 + (windowX/windowWidth)*2
  in[0]=(wx-vp[0])/vp[2]*2.0f - 1.0f
  ' Y = -1 + (windowY/windowHeight)*2
  in[1]=(wy-vw[1])/vp[3]*2.0f - 1.0f
  ' Z 0 ... 1 to -1 ... +1
  in[2]=2.0f*wz-1.0
  ' W
  in[3]=1.0f
  ' r = invPMV * in
  mul_mat4x4f_v4f(r,invPMV,in)
  w = r[3] : if (W = 0.0f) then return false
  ' XYZ/W
  w=1.0f/w: ob[0]=r[0]*w : ob[1]=r[1]*w : ob[2]=r[2]*w
  return true
end function

sub Frustum(byref proj4x4f as single ptr, _ ' result mat4x4f
            byref left_  as const single, _
            byref right_ as const single, _
            byref bottom as const single, _
            byref top    as const single, _
            byref znear  as const single, _ 
            byref zfar   as const single)
  dim as const single t1 = 2.0*znear
  dim as const single t2 = right_ - left_
  dim as const single t3 = top    - bottom
  dim as const single t4 = zfar   - znear
  dim as const single t5 = right_ + left_
  dim as const single t6 = top    + bottom
  dim as const single t7 = -zfar  - znear 
  dim as const single t8 = -t1   *zfar
  proj4x4f[ 0] = t1/t2 : proj4x4f[ 1] = 0.0   : proj4x4f[ 2] = 0.0   : proj4x4f[ 3] = 0.0
  proj4x4f[ 4] = 0.0   : proj4x4f[ 5] = t1/t3 : proj4x4f[ 6] = 0.0   : proj4x4f[ 7] = 0.0
  proj4x4f[ 8] = t5/t2 : proj4x4f[ 9] = t6/t3 : proj4x4f[10] = t7/t4 : proj4x4f[11] =-1.0
  proj4x4f[12] = 0.0   : proj4x4f[13] = 0.0   : proj4x4f[14] = t8/t4 : proj4x4f[15] = 0.0
end sub
 ' build perspective projection matrix
sub Perspective(byref proj4x4f as single ptr, _ ' result mat4x4f
                byref fov   as const single, _
                byref ratio as const single, _
                byref znear as const single, _
                byref zfar  as const single)
  dim as single ymax = znear*tan(fov * atn(1)/90.0) ' deg to rad
  dim as single xmax = ymax*ratio
  Frustum(proj4x4f, -xmax, xmax, -ymax, ymax, znear, zfar)
end sub





