#pragma once
#lang "fb"
#include "tokamak-c.bi"

' This is an example to show you how easy you can extends a neClass to your own needs.

' Remember the neTerrain class is a static collision shape bulid from an neTriangleMesh.
' In this example I extend the neTriangleMesh to build a neGround class. 

' I implement only a neGround constructor and use AddVertex and addTriangle from neTriangleMesh class !

' The physics renderer I wrote can render neTriangleMeshes so it can draw any extended mesh class also.
type neGround extends neTriangleMesh
  ' create a ground XZ plane of 10Km * 10Km at ground Y-Level 0.
  declare constructor (byval xzSize      as single = 10000.0f, _
                       byval groundLevel as single = 0.0f) ' y-position
end type

' Create a ground plane as neTriangleMesh
constructor neGround(byval xzSize as single, _
                     byval groundLevel as single)
  xzSize = neAbs(xzSize)\2
  if xzSize<1 then xzSize=1  
  
  ' build triangle mesh for the ground surface
  var A = AddVertex(-xzSize,groundLevel,-xzSize)
  var B = AddVertex(-xzSize,groundLevel, xzSize)
  var C = AddVertex( xzSize,groundLevel, xzSize)
  var D = AddVertex( xzSize,groundLevel,-xzSize)
  ' A--------D
  ' |  1   / |
  ' |    /   |
  ' |  /     |
  ' |/   2   |
  ' B--------C
  ' add triangle "1" from vertices A,B,D (counter clockwise)
  AddTriangle(A,B,D)
  ' add triangle "2" from vertices D,B,C (counter clockwise)
  AddTriangle(D,B,C)
  ' In the rare case that the camera position are under the ground level
  ' define the backfaces also only two more triangles :-)
  ' add triangle "3" from vertices A,D,B (clockwise)
  AddTriangle(A,D,B)
  ' add triangle "4" from vertices D,C,B (clockwise)
  AddTriangle(D,C,B)  
end constructor

